unit UnidadNuevoRepostaje;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Mask, DBCtrls, dxCntner, dxEditor, dxExEdtr, dxEdLib,
  dxDBELib, ExtCtrls, Buttons, db;

type
  TformNuevoRepostaje = class(TForm)
    Label1: TLabel;
    txtMatricula: TDBLookupComboBox;
    Label2: TLabel;
    txtConductor: TDBLookupComboBox;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    txtImporte: TDBEdit;
    Label7: TLabel;
    txtConsumo: TDBEdit;
    txtFecha: TdxDBDateEdit;
    txtKm: TdxDBCalcEdit;
    txtLitros: TdxDBCalcEdit;
    Panel1: TPanel;
    BCancelar: TBitBtn;
    BAceptar: TBitBtn;
    procedure BCancelarClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BAceptarClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure txtMatriculaExit(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formNuevoRepostaje: TformNuevoRepostaje;

implementation

uses UnidadDatos, UnidadProcedimientos;

{$R *.dfm}

procedure TformNuevoRepostaje.BCancelarClick(Sender: TObject);
begin
  Close;
end;

procedure TformNuevoRepostaje.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  if (Datos.TConsumo.State = dsinsert) or
      (datos.TConsumo.State = dsedit) then
    datos.TConsumo.post;
  Action := caFree;
end;

procedure TformNuevoRepostaje.BAceptarClick(Sender: TObject);
var
  consumomedio, litrosactual,kilometros,kmactual:double;
  fechaactual:tdatetime;
  matriculaactual:string;
begin
   if txtMatricula.Text = '' then
  begin
    MessageDlg('Debe seleccionar la matrcula para el repostaje.',
        mtWarning, [mbok],0);
    txtMatricula.SetFocus;
    exit;
  end;
  if txtConductor.Text = '' then
  begin
    MessageDlg('Debe seleccionar el conductor para el repostaje.',
        mtWarning, [mbok],0);
    txtConductor.SetFocus;
    exit;
  end;
  fechaactual := datos.dconsumo.dataset.fieldbyname('Fecha').value;
  kmactual := datos.dconsumo.dataset.fieldbyname('Km').value;
  litrosactual := datos.dconsumo.dataset.fieldbyname('Litros').value;
  matriculaactual := datos.dconsumo.dataset.fieldbyname('Matricula').value;
  datos.c.close;
  datos.c.SQL.Clear;
  datos.c.sql.add('SELECT Matricula, Fecha, Km');
  datos.c.sql.add('FROM Combustible');
  datos.c.sql.add('WHERE Fecha <= :FechaA AND Matricula = :MatriculaA');
  datos.c.sql.add('ORDER BY Fecha DESC, Km DESC');
  datos.c.ParamByName('FechaA').value := fechaactual;
  datos.c.ParamByName('MatriculaA').value := matriculaactual;
  datos.c.ExecSQL;
  datos.c.open;
  datos.c.first;
  if datos.c.RecordCount > 1 then
  begin
    datos.c.Next;
    if not varisnull(datos.c.fieldbyname('Km').value) then
      kilometros := kmactual - datos.c.fieldbyname('Km').value
    else
      kilometros := 0;
    if (kilometros > 0) and (litrosactual > 0)then
      consumomedio := (litrosactual * 100) / kilometros
    else
      consumomedio := 0;
  end
  else
    consumomedio := 0;
  if (consumomedio <> 0) then
  begin
    datos.dconsumo.dataset.edit;
    datos.dconsumo.dataset.fieldbyname('Consumo').value := redondear (consumomedio, 2);
    datos.dconsumo.dataset.post;
  end;
  if (datos.dconsumo.DataSet.State = dsinsert) or
      (datos.dconsumo.DataSet.State = dsedit) then
    datos.dconsumo.dataset.post;
  close;  
end;

procedure TformNuevoRepostaje.FormShow(Sender: TObject);
begin
  Datos.TConsumo.Insert;
  Datos.TConsumo.fieldbyname('Fecha').value := date;
end;

procedure TformNuevoRepostaje.txtMatriculaExit(Sender: TObject);
begin
  if Datos.TVehiculos.Locate('Matricula', txtMatricula.Text, []) then
  begin
    if not varisnull(datos.TVehiculosChofer.Value) then
      txtConductor.KeyValue := datos.TVehiculosChofer.Value;
  end;
end;

end.
